Name:           element-desktop
Group:          Networking/Instant messaging
Version:        1.11.77
Release:        %mkrel 1
Summary:        A glossy Matrix collaboration client - desktop
License:        Apache-2.0
URL:            https://github.com/vector-im/element-desktop
Source0:        https://github.com/element-hq/element-desktop/archive/refs/tags/v%{version}.tar.gz#/element-desktop-%{version}.tar.gz
Source1:        io.element.Element.desktop

BuildRequires:  asar
BuildRequires:  cargo
BuildRequires:  ccache
BuildRequires:  element-web >= %{version}
BuildRequires:  hicolor-icon-theme
BuildRequires:  moreutils
BuildRequires:  nodejs
BuildRequires:  pkgconfig(libsecret-1)
BuildRequires:  pkgconfig(sqlcipher)
BuildRequires:  pkgconfig(zlib)
BuildRequires:  python3
BuildRequires:  rust
BuildRequires:  yarnpkg

Requires:       element-web = %{version}

%global debug_package %{nil}

# hak*.tar.gz only available for those architectures
ExclusiveArch:  x86_64 aarch64

%description
A glossy Matrix collaboration client - desktop

%prep
%autosetup -p1

# build tools expect python3 interpreter behind "python"
mkdir -p $HOME/bin
ln -sf /usr/bin/python3 $HOME/bin/python

%build

#squidf: FIXME yarn --offline add hak keytar seshat matrix-seshat
yarn add hak keytar seshat matrix-seshat


yarn install # --frozen-lockfile
yarn build

%install
install -d -m 0755  %{buildroot}%{_bindir}/
install -d -m 0755  %{buildroot}%{_libdir}/%{name}

# Install binaries to /usr/lib
cp -r dist/linux-unpacked/* %{buildroot}%{_libdir}/%{name}/

# add the webapp with a symlink to the system package
ln -s %{_datadir}/webapps/element %{buildroot}%{_libdir}/%{name}/resources/webapp
# add png to fix systray icone before 1st notification
install -d -m 0755 %{buildroot}%{_libdir}/%{name}/img
install -m 0644 res/img/element.png %{buildroot}%{_libdir}/%{name}/img
install -m 0644 res/img/element.ico %{buildroot}%{_libdir}/%{name}/img

# Config file
install -m 0755 -d %{buildroot}%{_sysconfdir}/element
install -m 0644 element.io/release/config.json "%{buildroot}%{_sysconfdir}/element/config.json"

install -m 0755 -d %{buildroot}%{_sysconfdir}/webapps/element
ln -s %{_sysconfdir}/element/config.json "%{buildroot}%{_sysconfdir}/webapps/element/config.json"

# From element-web to make symlink check happy
install -d -m 0755 "%{buildroot}%{_datadir}/webapps/element/"
ln -s %{_sysconfdir}/element/config.json "%{buildroot}%{_datadir}/webapps/element/config.json"

# Desktop file
install -d -m 0755 %{buildroot}%{_datadir}/applications
desktop-file-install --dir %{buildroot}%{_datadir}/applications/ %{SOURCE1}

# Icons
for i in 16 24 48 64 96 128 256 512; do
	install -d -m 0755 %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/
	install -m 0644 build/icons/${i}x${i}.png %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/io.element.Element.png
done
install -d -m 0755 %{buildroot}%{_iconsdir}/hicolor/scalable/apps
ln -s %{_iconsdir}/hicolor/scalable/apps/element.svg %{buildroot}%{_iconsdir}/hicolor/scalable/apps/io.element.Element.svg


install -d -m 0755  %{buildroot}/%{_bindir}
ln -s %{_libdir}/%{name}/element-desktop %{buildroot}/%{_bindir}


%files
%license LICENSE
%{_bindir}/%{name}

%{_libdir}/%{name}{,.*}

%config(noreplace) %{_sysconfdir}/element/config.json
%{_sysconfdir}/webapps/element/config.json

%{_datadir}/webapps/element/config.json
%{_datadir}/applications/io.element.Element.desktop

%{_iconsdir}/hicolor/*/apps/*.png
%{_iconsdir}/hicolor/scalable/apps/io.element.Element.svg


%changelog
* Sat Jun 15 2024 squidf <squid-f> 1.11.68-2
- Update to 1.11.68

* Sun Apr 28 2024 squidf <squid-f> 1.11.65-2.5
- Do not require Nodejs-electron

* Sun Apr 28 2024 squidf <squid-f> 1.11.65-2.1
- Build with Element-Web 1.11.65
- Build with Electron 29.3.1
- Clean up BR

* Tue Apr 23 2024 SurfZoid <surfzoid> 1.11.65-1
- Update to 1.11.65

* Wed Apr 17 2024 SurfZoid <surfzoid> 1.11.64-1
- Initial MGA version 1.11.64 based on openSUSE package
